#!/bin/sh
# The next line is executed by /bin/sh, but not tcl \
exec tclsh "$0" ${1+"$@"}

set ::TEST 0
set ::VERBOSE 1

proc modify {file} {
    if {![file writable $file]} {
	puts stderr "NO PERMISSIONS TO MODIFY $file"
    }
    set fid [open $file r+]
    set data [read $fid]
    if {[regexp {([^@]+)@cvs.sourceforge.net:/cvsroot/(.+)\n} $data \
	    -> user proj]} {
	set proj [string trim $proj]
	set new $user@$proj.cvs.sourceforge.net:/cvsroot/$proj
	if {$::VERBOSE} {
	    puts "MODIFY $file:\nwas\t${data}now\t$new"
	}
	if {!$::TEST} {
	    seek $fid 0
	    puts $fid $new
	}
    } elseif {$::VERBOSE} {
	puts -nonewline "UNMODIFIED $file:\nwas\t${data}"
    }
    close $fid
}

proc process {dir} {
    set files [glob -nocomplain -directory $dir *]
    set taildir [file tail $dir]
    foreach file $files {
	if {[file isfile $file]} {
	    if {$taildir eq "CVS" && [file tail $file] eq "Root"} {
		modify $file
	    }
	} elseif {[file isdirectory $file]} {
	    process $file
	}
    }
}

proc do {argv} {
    if {[llength $argv] == 0} { set argv [list [pwd]] }
    foreach arg $argv {
	process [file normalize $arg]
    }
}
do $::argv
